"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Device;
(function (Device) {
    Device["Browser"] = "browser";
    Device["Server"] = "server";
    Device["Native"] = "native";
})(Device = exports.Device || (exports.Device = {}));
const { Browser, Server, Native } = Device;
const canUseDOM = !!(typeof window !== 'undefined' &&
    window.document &&
    window.document.createElement);
const canUseNative = typeof navigator != 'undefined' && navigator.product == 'ReactNative';
const device = canUseNative ? Native : canUseDOM ? Browser : Server;
const SSRObject = {
    isBrowser: device === Browser,
    isServer: device === Server,
    isNative: device === Native,
    device,
    canUseWorkers: typeof Worker !== 'undefined',
    canUseEventListeners: device === Browser && !!window.addEventListener,
    canUseViewport: device === Browser && !!window.screen,
};
const toArrayObject = () => Object.assign(Object.values(SSRObject), SSRObject);
let useSSRObject = toArrayObject();
exports.weAreServer = () => {
    SSRObject.isServer = true;
    useSSRObject = toArrayObject();
};
exports.useSSR = () => useSSRObject;
exports.default = exports.useSSR;
//# sourceMappingURL=useSSR.js.map